## ausweisapp2 1.26.1

=== CMakeLists.txt ===
if(WIN32)
	cmake_minimum_required(VERSION 3.19.0)
else()
	cmake_minimum_required(VERSION 3.13.0)
endif()

if(POLICY CMP0020)
	cmake_policy(SET CMP0020 NEW)
endif()

if(POLICY CMP0023)
	cmake_policy(SET CMP0023 NEW)
endif()

if(POLICY CMP0046)
	cmake_policy(SET CMP0046 NEW)
endif()

if(POLICY CMP0048)
	cmake_policy(SET CMP0048 NEW)
endif()

if(POLICY CMP0054)
	cmake_policy(SET CMP0054 NEW)
endif()

if(POLICY CMP0063)
	cmake_policy(SET CMP0063 NEW)
endif()

if(POLICY CMP0071)
	cmake_policy(SET CMP0071 NEW)
endif()

if(POLICY CMP0072)
	cmake_policy(SET CMP0072 NEW)
endif()

if(POLICY CMP0074)
	cmake_policy(SET CMP0074 NEW)
endif()

if(POLICY CMP0076)
	cmake_policy(SET CMP0076 NEW)
endif()

if(POLICY CMP0092)
	cmake_policy(SET CMP0092 NEW)
endif()

# "tools.only" can be defined to disable the normal build and enable
# cmdline "tools" only. For example: "make format" or "make package_source"
if(tools.only)
	set(LANGUAGES NONE)
else()
	set(LANGUAGES CXX)
endif()

if(UNIX AND NOT IOS)
	set(CMAKE_OSX_DEPLOYMENT_TARGET 10.15 CACHE STRING "Required macOS version")
endif()

project(AusweisApp2 VERSION 1.26.1 LANGUAGES ${LANGUAGES})

# Set TWEAK if not defined in PROJECT_VERSION above to
# have a valid tweak version without propagating it
if(NOT PROJECT_VERSION_TWEAK)
	set(PROJECT_VERSION_TWEAK 0)
endif()

if(APPLE AND CMAKE_VERSION VERSION_GREATER_EQUAL "3.16" AND NOT tools.only)
	enable_language(OBJCXX)
endif()

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT AND (IOS OR ANDROID))
	set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/dist" CACHE PATH "default install path" FORCE)
endif()
set(CMAKE_DIR "${PROJECT_SOURCE_DIR}/cmake")
set(CMAKE_MODULE_PATH "${CMAKE_DIR}")
option(BUILD_SHARED_LIBS "Enable build of shared libraries")
option(INTEGRATED_SDK "Build platform specific SDK" OFF)
option(CONTAINER_SDK "Build container specific SDK" OFF)

if(CONTAINER_SDK)
	set(INTEGRATED_SDK ON)
endif()

include(Helper)

if(NOT VENDOR)
	if(EXISTS "${CMAKE_DIR}/Vendor.internal.cmake")
		include(Vendor.internal)
	elseif(LINUX OR BSD)
		set(VENDOR "") # Qt uses Organization for paths
	else()
		set(VENDOR AusweisApp2_CE) # CommunityEdition
	endif()
endif()
if(VENDOR MATCHES "Governikus")
	set(VENDOR_GOVERNIKUS TRUE)
	set(LICENSE_FILE "${PROJECT_SOURCE_DIR}/LICENSE.officially.txt")
else()
	set(LICENSE_FILE "${PROJECT_SOURCE_DIR}/LICENSE.txt")
endif()

message(STATUS "VENDOR: ${VENDOR}")
message(STATUS "VERSION: ${PROJECT_VERSION}")

if(ANDROID)
	if(NOT BUILD_PREVIEW)
		set(BUILD_PREVIEW false)
	endif()
	message(STATUS "BUILD_PREVIEW: ${BUILD_PREVIEW}")

	if(NOT ANDROID_VERSION_CODE)
		set(ANDROID_VERSION_CODE 0)
	endif()
	message(STATUS "ANDROID_VERSION_CODE: ${ANDROID_VERSION_CODE}")
endif()

if(IOS)
	if(NOT USE_DISTRIBUTION_PROFILE)
		set(USE_DISTRIBUTION_PROFILE false)
	endif()
	message(STATUS "USE_DISTRIBUTION_PROFILE: ${USE_DISTRIBUTION_PROFILE}")
endif()

if("${PROJECT_BINARY_DIR}" STREQUAL "${PROJECT_SOURCE_DIR}" AND NOT FORCE_SOURCE_BUILD)
	message(FATAL_ERROR "in tree building is not supported!")
endif()

if(CMAKE_BUILD_TYPE)
	string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE)
else()
	set(CMAKE_BUILD_TYPE "DEBUG" CACHE STRING "build type configuration" FORCE)
endif()

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(SRC_DIR ${PROJECT_SOURCE_DIR}/src)
set(TEST_DIR ${PROJECT_SOURCE_DIR}/test)
set(DOCS_DIR ${PROJECT_SOURCE_DIR}/docs)
set(RESOURCES_DIR ${PROJECT_SOURCE_DIR}/resources)
set(PACKAGING_DIR ${RESOURCES_DIR}/packaging)
set(COPYRIGHT_TEXT "2014-2022 ${VENDOR}")
if(APPLE)
	string(REPLACE " \& " " \&amp; " COPYRIGHT_TEXT ${COPYRIGHT_TEXT})
endif()
set(BUNDLE_IDENTIFIER com.governikus.ausweisapp2)

include(Tools)
include(DVCS)
add_subdirectory(docs)

include(Appcast)
include(Messages)
if(tools.only)
	include(Packaging)
	return()
endif()

if(CMAKE_BUILD_TYPE STREQUAL "DEBUG" AND NOT CONTAINER_SDK)
	set(VALGRIND_SUPPRESSIONS "${CMAKE_PREFIX_PATH}/test/valgrind.supp")
	if(NOT EXISTS "${VALGRIND_SUPPRESSIONS}")
		set(VALGRIND_SUPPRESSIONS "${CMAKE_SOURCE_DIR}/libs/test/valgrind.supp")
	endif()
	message(STATUS "Using valgrind suppressions: ${VALGRIND_SUPPRESSIONS}")
	set(VALGRIND_COMMAND_OPTIONS "--tool=memcheck --leak-check=full --show-leak-kinds=definite --errors-for-leak-kinds=definite --error-exitcode=1 --gen-suppressions=all --suppressions=${VALGRIND_SUPPRESSIONS}")

	include(CTest)
	configure_file("${CMAKE_DIR}/CTestCustom.cmake.in" "${CMAKE_BINARY_DIR}/CTestCustom.cmake" @ONLY)

	set(SONAR_CACHE_DIR ${CMAKE_BINARY_DIR}/../cache)
	if(NOT EXISTS "${SONAR_CACHE_DIR}")
		set(SONAR_CACHE_DIR ${CMAKE_BINARY_DIR})
	endif()
	get_filename_component(SONAR_CACHE_DIR ${SONAR_CACHE_DIR} ABSOLUTE)
	configure_file("${RESOURCES_DIR}/sonar-project.properties.in" "${CMAKE_BINARY_DIR}/sonar-project.properties" @ONLY)
endif()

option(USE_SMARTEID "Enable Smart-eID" OFF)

include(Libraries)
include(CompilerFlags)

if(LINUX OR BSD)
	include(GNUInstallDirs)
endif()

add_subdirectory(resources)
add_subdirectory(src)

if(TARGET ${Qt}::Test AND NOT IOS)
	add_subdirectory(test)
endif()

if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/utils")
	add_subdirectory(utils)
endif()

include(Packaging)

=== debian/changelog ===
ausweisapp2 (1.26.1-1) unstable; urgency=medium

  * New upstream release

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Tue, 20 Dec 2022 23:03:05 +0100

ausweisapp2 (1.26.0-1) unstable; urgency=medium

  * New upstream release

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sun, 18 Dec 2022 20:17:04 +0100

## ausweisapp2 1.26.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -60,7 +60,7 @@
 	set(CMAKE_OSX_DEPLOYMENT_TARGET 10.15 CACHE STRING "Required macOS version")
 endif()
 
-project(AusweisApp2 VERSION 1.26.1 LANGUAGES ${LANGUAGES})
+project(AusweisApp2 VERSION 1.26.2 LANGUAGES ${LANGUAGES})
 
 # Set TWEAK if not defined in PROJECT_VERSION above to
 # have a valid tweak version without propagating it
@@ -143,7 +143,7 @@
 set(DOCS_DIR ${PROJECT_SOURCE_DIR}/docs)
 set(RESOURCES_DIR ${PROJECT_SOURCE_DIR}/resources)
 set(PACKAGING_DIR ${RESOURCES_DIR}/packaging)
-set(COPYRIGHT_TEXT "2014-2022 ${VENDOR}")
+set(COPYRIGHT_TEXT "2014-2023 ${VENDOR}")
 if(APPLE)
 	string(REPLACE " \& " " \&amp; " COPYRIGHT_TEXT ${COPYRIGHT_TEXT})
 endif()

=== docs/CMakeLists.txt ===
if(SPHINX_FOUND)
	SPHINX_GEN("${CMAKE_CURRENT_SOURCE_DIR}/releasenotes" "notes" BUILDER singlehtml html latex text)

	SPHINX_GEN("${CMAKE_CURRENT_SOURCE_DIR}/sdk" "sdk" BUILDER changes html latex DEFAULT_LANG en)

	SPHINX_GEN("${CMAKE_CURRENT_SOURCE_DIR}/installation" "inst" BUILDER changes html latex)

	SPHINX_GEN("${CMAKE_CURRENT_SOURCE_DIR}/integration" "inte" BUILDER changes html latex)
else()
	message(STATUS "No documentation will be generated")
endif()

=== libs/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8.0)

if(POLICY CMP0010)
	cmake_policy(SET CMP0010 NEW)
endif()

if(POLICY CMP0020)
	cmake_policy(SET CMP0020 NEW)
endif()

if(POLICY CMP0135)
	cmake_policy(SET CMP0135 NEW)
endif()

if(NOT ANDROID AND NOT IOS)
	set(COMPILER_SEARCH C CXX)
endif()

project(AusweisApp2_Libs ${COMPILER_SEARCH})

option(INTEGRATED_SDK "Build integrated specific SDK" OFF)
option(CONTAINER_SDK "Build container specific SDK" OFF)

if(CONTAINER_SDK)
	set(INTEGRATED_SDK ON)
	set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/../cmake;${PROJECT_SOURCE_DIR}")
else()
	set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/../cmake")
endif()

include(ExternalProject)
include(Helper)
include(DVCS)


if(MSVC)
	find_program(MAKE jom CMAKE_FIND_ROOT_PATH_BOTH)
	if(NOT MAKE)
		find_program(MAKE nmake CMAKE_FIND_ROOT_PATH_BOTH)
	endif()
else()
	find_program(MAKE make CMAKE_FIND_ROOT_PATH_BOTH)
endif()

if(MINGW AND NOT MAKE)
	find_program(MAKE mingw32-make CMAKE_FIND_ROOT_PATH_BOTH)
endif()

if(MAKE)
	message(STATUS "Using 'make' command... ${MAKE}")
else()
	message(FATAL_ERROR "Cannot find 'make' command")
endif()

if(NOT DEFINED PROCESSOR_COUNT)
	set(PROCESSOR_COUNT $ENV{PROCESSOR_COUNT})
endif()

if(NOT DEFINED PROCESSOR_COUNT)
	include(ProcessorCount)
	ProcessorCount(PROCESSOR_COUNT)
endif()

if(NOT PROCESSOR_COUNT EQUAL 0 AND NOT MAKE MATCHES "nmake")
	set(MAKE_JOBS -j${PROCESSOR_COUNT})
	message(STATUS "PROCESSOR_COUNT: ${PROCESSOR_COUNT}")
endif()

if(CMAKE_BUILD_TYPE)
	string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE)
else()
	set(CMAKE_BUILD_TYPE "DEBUG" CACHE STRING "build type configuration" FORCE)
endif()

if(NOT ${CMAKE_BUILD_TYPE} STREQUAL "DEBUG" AND NOT ${CMAKE_BUILD_TYPE} STREQUAL "RELEASE" AND NOT ${CMAKE_BUILD_TYPE} STREQUAL "RELWITHDEBINFO")
	message(FATAL_ERROR "CMAKE_BUILD_TYPE is invalid! Available options: RELEASE, RELWITHDEBINFO, DEBUG")
endif()

if(MSVC)
	FIND_HOST_PACKAGE(Perl REQUIRED)
else()
	set(PERL_EXECUTABLE perl)
endif()

set(PATCH_CMAKE ${CMAKE_CURRENT_BINARY_DIR}/patch.cmake)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/patch.cmake.in ${PATCH_CMAKE} @ONLY)

if(NOT DESTINATION_DIR)
	set(DESTINATION_DIR ${PROJECT_BINARY_DIR}/dist)
endif()

configure_file(${PROJECT_SOURCE_DIR}/test/valgrind.supp.${CMAKE_BUILD_TYPE} ${DESTINATION_DIR}/test/valgrind.supp COPYONLY)

if(NOT PACKAGES_DIR)
	set(PACKAGES_DIR $ENV{PACKAGES_DIR})
	if(NOT PACKAGES_DIR)
		message(STATUS "Define PACKAGES_DIR for local packages")
		set(PACKAGES_DIR ${PROJECT_BINARY_DIR}/download)
	endif()
endif()

string(REPLACE "\\" "/" PACKAGES_DIR ${PACKAGES_DIR})
set_directory_properties(PROPERTIES EP_PREFIX ${CMAKE_CURRENT_BINARY_DIR}/b)
include(Messages)

if(NOT CMAKE_HOST_SYSTEM_NAME STREQUAL CMAKE_SYSTEM_NAME)
	get_filename_component(compiler "${CMAKE_CXX_COMPILER}" NAME)
	string(REGEX REPLACE "[a-z|+]+$" "" CROSS_PREFIX "${compiler}")
endif()

################################## Versions
set(QT 6.4.1)
set(QT_HASH e20b850b6134098a7f2e7701cfddfb213c6cf394b9e848e6fbc5b0e89dcfcc09)

set(OPENSSL 3.0.7)
set(OPENSSL_HASH 83049d042a260e696f62406ac5c08bf706fd84383f945cf21bd61e9ed95c396e)

################################## Files
set(QT_FILE qt-everywhere-src-${QT}.tar.xz)
set(OPENSSL_FILE openssl-${OPENSSL}.tar.gz)

################################## Downloads
if("${QT}" MATCHES "alpha|beta|rc")
	set(QT_DEST_DIR development_releases)
else()
	set(QT_DEST_DIR archive) # official_releases
endif()

string(REPLACE "." ";" QT_VERSION_LIST ${QT})
list(GET QT_VERSION_LIST 0 QT_MAJOR_VERSION)
list(GET QT_VERSION_LIST 1 QT_MINOR_VERSION)
set(QT_SUBVERSION ${QT_MAJOR_VERSION}.${QT_MINOR_VERSION})
list(APPEND QT_URLS https://download.qt.io/${QT_DEST_DIR}/qt/${QT_SUBVERSION}/${QT}/single/${QT_FILE})
list(APPEND QT_URLS https://ftp.fau.de/qtproject/${QT_DEST_DIR}/qt/${QT_SUBVERSION}/${QT}/single/${QT_FILE})

set(OPENSSL_SOURCE https://www.openssl.org/source)
if("${OPENSSL}" MATCHES "SNAP")
	list(APPEND OPENSSL_URLS ${OPENSSL_SOURCE}/snapshot/${OPENSSL_FILE})
else()
	string(SUBSTRING ${OPENSSL} 0 5 OPENSSL_SUBVERSION)
	list(APPEND OPENSSL_URLS ${OPENSSL_SOURCE}/${OPENSSL_FILE})
	list(APPEND OPENSSL_URLS ${OPENSSL_SOURCE}/old/${OPENSSL_SUBVERSION}/${OPENSSL_FILE})
endif()



set(ENABLED_TARGETS)

################################## OpenSSL
#########################################################################
list(APPEND ENABLED_TARGETS openssl)

set(OPENSSL_CONFIGURE_FLAGS no-camellia no-bf no-aria no-seed no-poly1305 no-srp no-gost no-idea no-mdc2 no-rc2 no-rc4 no-rc5 no-srtp no-sm2 no-sm3 no-sm4)
set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-ct no-dgram no-cast no-chacha no-blake2 no-rmd160 no-scrypt no-siphash no-whirlpool no-md4 no-des)
set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-tls1 no-tls1-method no-tls1_1 no-tls1_1-method no-tls1_3 no-ssl3 no-ssl3-method no-dtls no-dtls1-method no-dtls1_2-method)
set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-engine no-async no-dso no-comp no-ts no-makedepend no-tests no-legacy shared)

if(${CMAKE_BUILD_TYPE} STREQUAL "DEBUG")
	set(OPENSSL_CONFIGURE_FLAGS --debug ${OPENSSL_CONFIGURE_FLAGS})
	if(MSVC)
		ADD_FLAG(/Od NOQUOTES VAR OPENSSL_COMPILER_FLAGS)
	endif()
else()
	set(OPENSSL_CONFIGURE_FLAGS no-ui-console no-filenames ${OPENSSL_CONFIGURE_FLAGS})
	ADD_FLAG(-Os NOQUOTES VAR OPENSSL_COMPILER_FLAGS)
endif()

if(WIN32)
	ADD_FLAG(-Wl,--dynamicbase NOQUOTES VAR OPENSSL_COMPILER_FLAGS USE_SAME_FOR_LINKER)
	ADD_FLAG(-Wl,--nxcompat NOQUOTES VAR OPENSSL_COMPILER_FLAGS USE_SAME_FOR_LINKER)
	ADD_FLAG(-Wl,--high-entropy-va NOQUOTES VAR OPENSSL_COMPILER_FLAGS USE_SAME_FOR_LINKER)

	if(MSVC AND MAKE MATCHES "jom")
		ADD_FLAG(/FS NOQUOTES VAR OPENSSL_COMPILER_FLAGS)
	endif()
else()
	ADD_FLAG(-fstack-protector-strong -fstack-protector NOQUOTES VAR OPENSSL_COMPILER_FLAGS)
endif()

if(IOS)
	if(CMAKE_OSX_SYSROOT MATCHES "iphonesimulator")
		set(OPENSSL_ARCH iossimulator-xcrun)
		set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-asm)
		if (CMAKE_OSX_ARCHITECTURES STREQUAL "arm64")
			set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} "-arch arm64")
		endif()
	else()
		set(OPENSSL_ARCH ios64-cross)
		string(REGEX REPLACE "/SDKs/.*" "" CROSS_TOP_DEV_ROOT "${CMAKE_OSX_SYSROOT}")
		set(OPENSSL_ENV CROSS_TOP=${CROSS_TOP_DEV_ROOT} CROSS_SDK=iPhoneOS.sdk)
	endif()
elseif(APPLE)
	if(NOT CMAKE_OSX_ARCHITECTURES AND CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "arm64")
		set(CMAKE_OSX_ARCHITECTURES arm64)
	endif()

	if(CMAKE_OSX_ARCHITECTURES STREQUAL "arm64")
		set(OPENSSL_ARCH darwin64-arm64-cc)
		set(OPENSSL_COMPILER_FLAGS ${OPENSSL_COMPILER_FLAGS} -mmacosx-version-min=11.0)
	else()
		set(OPENSSL_ARCH darwin64-x86_64-cc)
		set(OPENSSL_COMPILER_FLAGS ${OPENSSL_COMPILER_FLAGS} -mmacosx-version-min=10.15)
	endif()
elseif(MINGW OR CYGWIN)
	if(CMAKE_SIZEOF_VOID_P EQUAL 8)
		set(OPENSSL_ARCH mingw64)
	else()
		set(OPENSSL_ARCH mingw)
	endif()

	if(CMAKE_HOST_SYSTEM_NAME STREQUAL "Linux")
		set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} --cross-compile-prefix=${CROSS_PREFIX})
	endif()
elseif(MSVC)
	set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-asm)
	if(CMAKE_SIZEOF_VOID_P EQUAL 8)
		set(OPENSSL_ARCH VC-WIN64A)
	else()
		set(OPENSSL_ARCH VC-WIN32)
	endif()
elseif(ANDROID)
	if(CMAKE_ANDROID_ARCH_ABI STREQUAL "armeabi-v7a")
		set(OPENSSL_ARCH android-arm)
		set(OPENSSL_COMPILER_FLAGS ${OPENSSL_COMPILER_FLAGS} -mfloat-abi=softfp)
	elseif(CMAKE_ANDROID_ARCH_ABI STREQUAL "x86_64")
		set(OPENSSL_ARCH android-x86_64)
	elseif(CMAKE_ANDROID_ARCH_ABI STREQUAL "x86")
		set(OPENSSL_ARCH android-x86)
	elseif(CMAKE_ANDROID_ARCH_ABI STREQUAL "arm64-v8a")
		set(OPENSSL_ARCH android-arm64)
	else()
		message(FATAL_ERROR "CMAKE_ANDROID_ARCH_ABI not supported by openssl")
	endif()
	set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-stdio)

	get_filename_component(toolchain_bin "${CMAKE_C_COMPILER}" DIRECTORY)
	set(OPENSSL_ENV PATH=${toolchain_bin}/:$ENV{PATH} CC=clang CXX=clang++)

	if(ANDROID_NDK_REVISION VERSION_LESS "23")
		set(OPENSSL_COMPILER_FLAGS ${OPENSSL_COMPILER_FLAGS} -D__ANDROID_API__=${CMAKE_SYSTEM_VERSION})
	endif()
elseif(BSD)
	set(OPENSSL_ARCH BSD-x86_64)
elseif(LINUX)
	if(CMAKE_SIZEOF_VOID_P EQUAL 8)
		set(OPENSSL_ARCH linux-x86_64)
	else()
		set(OPENSSL_ARCH linux-generic32)
	endif()
else()
	message(FATAL_ERROR "Unsupported system")
endif()

if(OPENSSL_ENV)
	set(OPENSSL_ENV ${CMAKE_COMMAND} -E env ${OPENSSL_ENV})
endif()

ExternalProject_Add(openssl
	URL ${OPENSSL_URLS}
	URL_HASH SHA256=${OPENSSL_HASH}
	DOWNLOAD_DIR ${PACKAGES_DIR}

	PATCH_COMMAND ${CMAKE_COMMAND} -DCOMPONENT=openssl -P ${PATCH_CMAKE}
	CONFIGURE_COMMAND ${OPENSSL_ENV} ${PERL_EXECUTABLE} <SOURCE_DIR>/Configure --prefix=${DESTINATION_DIR} --libdir=lib ${OPENSSL_CONFIGURE_FLAGS} ${OPENSSL_ARCH} "${OPENSSL_COMPILER_FLAGS}"
	BUILD_COMMAND ${OPENSSL_ENV} ${MAKE} ${MAKE_JOBS}
	INSTALL_COMMAND ${OPENSSL_ENV} ${MAKE} ${MAKE_JOBS} install_sw
)

ExternalProject_Add_Step(openssl configdata
	COMMAND ${PERL_EXECUTABLE} configdata.pm --dump
	DEPENDEES configure
	DEPENDERS build
	WORKING_DIRECTORY <BINARY_DIR>)


if(MAC)
	set(OPENSSL_FILE_VERSION 3)
	add_custom_command(TARGET openssl POST_BUILD
		COMMAND install_name_tool -id libcrypto.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX} ${DESTINATION_DIR}/lib/libcrypto.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX}
		COMMAND install_name_tool -id libssl.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX} ${DESTINATION_DIR}/lib/libssl.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX}
		COMMAND install_name_tool -change ${DESTINATION_DIR}/lib/libcrypto.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX} libcrypto.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX} ${DESTINATION_DIR}/lib/libssl.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX})
endif()

if(IOS)
	# Remove this work-around! Do not build any .dylib or be able to use .dylib
	# Globbing is not supported by cmake command mode! This will work if executed with unix shell only.
	if(CMAKE_VERSION VERSION_LESS "3.17")
		add_custom_command(TARGET openssl POST_BUILD COMMAND ${CMAKE_COMMAND} -E remove ${DESTINATION_DIR}/lib/*.dylib)
	else()
		add_custom_command(TARGET openssl POST_BUILD COMMAND ${CMAKE_COMMAND} -E rm -f ${DESTINATION_DIR}/lib/*.dylib)
	endif()
elseif(ANDROID)
	if(CMAKE_VERSION VERSION_LESS "3.17")
		add_custom_command(TARGET openssl POST_BUILD COMMAND ${CMAKE_COMMAND} -E remove ${DESTINATION_DIR}/lib/*.a)
	else()
		add_custom_command(TARGET openssl POST_BUILD COMMAND ${CMAKE_COMMAND} -E rm -f ${DESTINATION_DIR}/lib/*.a)
	endif()
endif()

################################## Qt
#########################################################################
list(APPEND ENABLED_TARGETS qt)

if(${CMAKE_BUILD_TYPE} STREQUAL "DEBUG")
	if(APPLE)
		set(QT_CONFIGURE_FLAGS -debug-and-release) # debug-only framework builds are not supported on macOS
	else()
		set(QT_CONFIGURE_FLAGS -debug)
	endif()
	if(NOT INTEGRATED_SDK)
		set(QT_CONFIGURE_FLAGS_SHARED -qml-debug)
	endif()
else()
	set(QT_CONFIGURE_FLAGS -release)
	if(NOT WIN32)
		list(APPEND QT_CONFIGURE_FLAGS -optimize-size)
	endif()
	set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} $<$<CONFIG:RelWithDebInfo>:-force-debug-info>)
	if(NOT INTEGRATED_SDK)
		set(QT_CONFIGURE_FLAGS_SHARED -no-qml-debug)
	endif()
endif()

set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} -prefix ${DESTINATION_DIR})
set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} -system-proxies -openssl-linked -I ${DESTINATION_DIR}/include -L ${DESTINATION_DIR}/lib)

set(QT_CONFIGURE_FLAGS_SHARED ${QT_CONFIGURE_FLAGS_SHARED} -opensource -confirm-license)
set(QT_CONFIGURE_FLAGS_SHARED ${QT_CONFIGURE_FLAGS_SHARED} -nomake examples -nomake tests -no-mtdev -no-dbus -no-sql-sqlite)
set(QT_CONFIGURE_FLAGS_SHARED ${QT_CONFIGURE_FLAGS_SHARED} -qt-zlib -qt-pcre -qt-harfbuzz)
if(NOT INTEGRATED_SDK)
	set(QT_CONFIGURE_FLAGS_SHARED ${QT_CONFIGURE_FLAGS_SHARED} -qt-libpng -qt-libjpeg)
endif()

if(CMAKE_CXX_COMPILER_LAUNCHER STREQUAL "ccache")

=== resources/CMakeLists.txt ===
function(WRITE_QRC _dest_file _dir _prefix _files)
	file(WRITE "${_dest_file}" "<!DOCTYPE RCC><RCC version=\"1.0\"><qresource prefix=\"${_prefix}/\">\n")
	foreach(file ${_files})
		string(REPLACE "${_dir}/" "" file_alias "${file}")
		file(APPEND "${_dest_file}" "<file alias=\"${file_alias}\">${file}</file>\n")
	endforeach()
	file(APPEND "${_dest_file}" "</qresource></RCC>")
endfunction()

function(WRITE_GLOB_QRC _dest_file _dir _prefix _wildcard)
	file(GLOB_RECURSE files "${_dir}/${_wildcard}")
	WRITE_QRC("${_dest_file}" "${_dir}" "${_prefix}" "${files}")
endfunction()

function(ADD_SHADERS_TO_TARGET _target)
	if(TARGET ${Qt}::Qml AND QT6 AND NOT INTEGRATED_SDK)
		file(GLOB QT6_SHADERS "${RESOURCES_DIR}/shader/qt6/*.frag")
		message(STATUS "QT6_SHADERS " "${QT6_SHADERS}")
		foreach(shaderPath ${QT6_SHADERS})
			get_filename_component(shaderName ${shaderPath} NAME)
			list(APPEND QT6_SHADER_OUTPUTS ${shaderName})
		endforeach()
		message(STATUS "QT6_SHADER_OUTPUTS " "${QT6_SHADER_OUTPUTS}")
		qt6_add_shaders(${_target} "${_target}_shader"
				PRECOMPILE
				PREFIX "/shader/+qt6"
				FILES "${QT6_SHADERS}"
				OUTPUTS "${QT6_SHADER_OUTPUTS}")
	endif()
endfunction()


if(EXISTS "${CMAKE_DIR}/SmartService.internal.cmake")
	include(SmartService.internal)
endif()
configure_file(${RESOURCES_DIR}/config.json.in ${CMAKE_CURRENT_BINARY_DIR}/config.json @ONLY)


set(ausweisapp_config.qrc "${CMAKE_CURRENT_BINARY_DIR}/ausweisapp_config.qrc")
WRITE_QRC("${ausweisapp_config.qrc}" "${CMAKE_CURRENT_BINARY_DIR}" "" "${CMAKE_CURRENT_BINARY_DIR}/config.json")
if(INTEGRATED_SDK AND NOT CONTAINER_SDK)
	qt_add_resources(AusweisAppConfigQrc ${ausweisapp_config.qrc} OPTIONS -compress-algo zlib)
	ADD_OBJECT_LIBRARY(AusweisAppConfig ${AusweisAppConfigQrc})
else()
	list(APPEND QRC_FILES "${ausweisapp_config.qrc}")
endif()


if(NOT INTEGRATED_SDK OR BUILD_TESTING)
	list(APPEND QRC_FILES "ausweisapp.qrc")
endif()

if((IOS OR ANDROID) AND NOT INTEGRATED_SDK OR BUILD_TESTING)
	list(APPEND QRC_FILES "ausweisapp_mobile.qrc")
endif()

if (IOS)
	list(APPEND QRC_FILES "ausweisapp_ios.qrc")
elseif((ANDROID AND NOT INTEGRATED_SDK) OR BUILD_TESTING)
	list(APPEND QRC_FILES "ausweisapp_android.qrc")
endif()

if((DESKTOP AND NOT INTEGRATED_SDK) OR BUILD_TESTING)
	list(APPEND QRC_FILES "ausweisapp_desktop.qrc")
endif()

if((DESKTOP OR INTEGRATED_SDK) OR BUILD_TESTING)
	list(APPEND QRC_FILES "ausweisapp_webservice.qrc")
endif()


if(TARGET ${Qt}::Qml)
	file(GLOB_RECURSE QMLDIR_FILES "${CMAKE_CURRENT_SOURCE_DIR}/qml" qmldir)
	set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS ${QMLDIR_FILES})

	set(ausweisapp_qml.qrc "${CMAKE_CURRENT_BINARY_DIR}/ausweisapp_qml.qrc")
	WRITE_GLOB_QRC("${ausweisapp_qml.qrc}" "${CMAKE_CURRENT_SOURCE_DIR}/qml" "/qml" "*")
	list(APPEND QRC_FILES "${ausweisapp_qml.qrc}")

	set(ausweisapp_license.qrc "${CMAKE_CURRENT_BINARY_DIR}/ausweisapp_license.qrc")
	configure_file("${RESOURCES_DIR}/ausweisapp_license.qrc.in" "${ausweisapp_license.qrc}" @ONLY)
	list(APPEND QRC_FILES "${ausweisapp_license.qrc}")

	set(QML_IMPORT_PATH ${CMAKE_CURRENT_SOURCE_DIR}/qml CACHE STRING "qml files" FORCE)

	add_subdirectory(qml)
endif()

if(NOT INTEGRATED_SDK)
	file(GLOB TRANSLATION_FILES ${RESOURCES_DIR}/translations/*.ts)

	foreach(filepath ${TRANSLATION_FILES})
		get_filename_component(filename "${filepath}" NAME)
		string(REGEX MATCH "_(.*)\.ts$" _unused "${filename}")
		list(APPEND USED_TRANSLATIONS ${CMAKE_MATCH_1})
	endforeach()

	set_property(SOURCE ${TRANSLATION_FILES} PROPERTY OUTPUT_LOCATION ${CMAKE_CURRENT_BINARY_DIR}/translations)
	foreach(locale ${USED_TRANSLATIONS})
		file(COPY ${QT_INSTALL_TRANSLATIONS} DESTINATION ${CMAKE_CURRENT_BINARY_DIR} FILES_MATCHING REGEX "qtbase_${locale}")
	endforeach()
	file(GLOB EXISTING_QM_FILES ${CMAKE_CURRENT_BINARY_DIR}/translations/*.qm)

	option(UPDATE_TRANSLATIONS "Update translations/*.ts files (WARNING: make clean will delete the *.ts files!)")
	if(UPDATE_TRANSLATIONS)
		option(UPDATE_TRANSLATIONS_NO_OBSOLETE "Remove obsolete translations from translations/*.ts files )")

		set(LUPDATE_OPTIONS -extensions c,cpp,h,ui,m,mm,qml,js -no-ui-lines -locations none)
		if(UPDATE_TRANSLATIONS_NO_OBSOLETE)
			qt_create_translation(QM_FILES ${SRC_DIR} ${RESOURCES_DIR} ${TRANSLATION_FILES} OPTIONS ${LUPDATE_OPTIONS} -no-obsolete)
		else()
			qt_create_translation(QM_FILES ${SRC_DIR} ${RESOURCES_DIR} ${TRANSLATION_FILES} OPTIONS ${LUPDATE_OPTIONS})
		endif()

		configure_file("${CMAKE_DIR}/Translation.cmake.in" "${CMAKE_BINARY_DIR}/Translation.cmake" @ONLY)
		add_custom_target(update.translations COMMAND ${CMAKE_COMMAND} -P ${CMAKE_BINARY_DIR}/Translation.cmake DEPENDS ${QM_FILES})
		message(WARNING "'make clean' will delete *.ts files!")
	else()
		qt_add_translation(QM_FILES ${TRANSLATION_FILES})
	endif()

	list(APPEND QM_FILES ${EXISTING_QM_FILES})
	list(REMOVE_DUPLICATES QM_FILES)

	set(ausweisapp_translations.qrc "${CMAKE_CURRENT_BINARY_DIR}/ausweisapp_translations.qrc")
	WRITE_QRC("${ausweisapp_translations.qrc}" "${CMAKE_CURRENT_BINARY_DIR}" "" "${QM_FILES}")
	list(APPEND QRC_FILES "${ausweisapp_translations.qrc}")
endif()


if(QRC_FILES)
	set(RCC ${CMAKE_BINARY_DIR}/src/${PROJECT_NAME}.rcc)
	set(RCC ${RCC} PARENT_SCOPE)
	qt_add_binary_resources(AusweisAppRcc "${QRC_FILES}" DESTINATION ${RCC} OPTIONS -compress-algo zlib)
endif()

=== src/CMakeLists.txt ===
#####################################################################
# The main component that will link all necessary modules and plugins
# into AusweisApp2 executable for the specific platform.
#
# This component includes a main entry point and command line
# parser only. Everything else will be included from sub-modules.
#####################################################################

add_subdirectory(external)
add_subdirectory(global)
add_subdirectory(secure_storage)
add_subdirectory(settings)

add_subdirectory(file_provider)
add_subdirectory(configuration)
add_subdirectory(network)

add_subdirectory(export)
add_subdirectory(card)
add_subdirectory(services)

add_subdirectory(diagnosis)
add_subdirectory(ifd)
add_subdirectory(workflows)
add_subdirectory(ui)
add_subdirectory(core)
add_subdirectory(init)
add_subdirectory(whitelist_client)


if(IOS)
	if(NOT INTEGRATED_SDK)
		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/qml)
		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/packaging/ios/de.lproj)
		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/packaging/ios/launchscreen.storyboard)

		# Attention: the file names correspond to values in the Info.plist
		if(BUILD_PREVIEW)
			message(FATAL_ERROR "iOS preview not implemented")
		elseif(IS_DEVELOPER_VERSION)
			set(IOS_APPICON_PATH "beta/")
		else()
			set(IOS_APPICON_PATH "")
		endif()

		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/images/ios/appIcons/${IOS_APPICON_PATH}Images.xcassets)
		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/packaging/ios/Settings.bundle)
		list(APPEND IOS_RESOURCES ${RCC})
		set_source_files_properties(${RCC} PROPERTIES GENERATED TRUE)
	endif()
elseif(MAC)
	if(IS_DEVELOPER_VERSION)
		set(MACOS_APPICON_PATH "beta/")
	else()
		set(MACOS_APPICON_PATH "")
	endif()

	list(APPEND MAC_RESOURCES ${RESOURCES_DIR}/images/macos/${MACOS_APPICON_PATH}AusweisApp2.icns)
	list(APPEND MAC_RESOURCES ${PACKAGING_DIR}/macos/container-migration.plist)
	list(APPEND MAC_RESOURCES ${RCC})
	set_source_files_properties(${RCC} PROPERTIES GENERATED TRUE)
endif()

if(APPLE)
	set(CMAKE_XCODE_GENERATE_SCHEME ON)
	set(CMAKE_XCODE_SCHEME_DISABLE_MAIN_THREAD_CHECKER ON)

	if(MAC AND DEFINED CMAKE_PREFIX_PATH)
		set(CMAKE_XCODE_SCHEME_ENVIRONMENT "DYLD_LIBRARY_PATH=${CMAKE_PREFIX_PATH}/lib;DYLD_FRAMEWORK_PATH=${CMAKE_PREFIX_PATH}/lib")
	endif()
endif()

set(MAIN_FILE main.cpp)
if(IOS)
	if(INTEGRATED_SDK)
		add_library(AusweisApp SHARED ${MAIN_FILE} ${IOS_RESOURCES})
	else()
		add_executable(AusweisApp MACOSX_BUNDLE ${MAIN_FILE} ${IOS_RESOURCES})
	endif()
elseif(ANDROID OR (INTEGRATED_SDK AND NOT CONTAINER_SDK))
	add_library(AusweisApp SHARED ${MAIN_FILE})
elseif(MAC)
	add_executable(AusweisApp MACOSX_BUNDLE ${MAIN_FILE} ${MAC_RESOURCES})
else()
	add_executable(AusweisApp WIN32 ${MAIN_FILE} windows.rc)
endif()

if(TARGET AusweisAppRcc)
	add_dependencies(AusweisApp AusweisAppRcc)
endif()

target_link_libraries(AusweisApp PRIVATE AusweisAppInit)
if(ANDROID)
	set_target_properties(AusweisApp PROPERTIES OUTPUT_NAME "${PROJECT_NAME}_${CMAKE_ANDROID_ARCH_ABI}")
else()
	set_target_properties(AusweisApp PROPERTIES OUTPUT_NAME "${PROJECT_NAME}")
endif()

if(TARGET AusweisAppConfig)
	target_link_libraries(AusweisApp PRIVATE AusweisAppConfig)
endif()

ADD_SHADERS_TO_TARGET(AusweisApp)

if(APPLE)
	set(MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_BUNDLE_NAME ${PROJECT_NAME})
	set(MACOSX_BUNDLE_GUI_IDENTIFIER "${BUNDLE_IDENTIFIER}")
	set(MACOSX_BUNDLE_COPYRIGHT "${COPYRIGHT_TEXT}")

	if(IOS AND INTEGRATED_SDK)
		set(MACOSX_FRAMEWORK_BUNDLE_VERSION ${PROJECT_VERSION})
		set(MACOSX_FRAMEWORK_SHORT_VERSION_STRING ${PROJECT_VERSION})
		set_target_properties(AusweisApp PROPERTIES MACOSX_FRAMEWORK_NAME ${PROJECT_NAME})
		set_target_properties(AusweisApp PROPERTIES MACOSX_FRAMEWORK_IDENTIFIER "${BUNDLE_IDENTIFIER}")
		set_target_properties(AusweisApp PROPERTIES MACOSX_FRAMEWORK_INFO_PLIST "${PACKAGING_DIR}/ios/Info.framework.plist.in")
	elseif(IOS)
		set_target_properties(AusweisApp PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${PACKAGING_DIR}/ios/Info.plist.in")
	elseif(MAC AND NOT INTEGRATED_SDK)
		set_target_properties(AusweisApp PROPERTIES RESOURCE "${MAC_RESOURCES}")
		set_target_properties(AusweisApp PROPERTIES MACOSX_BUNDLE_ICON_FILE "${PROJECT_NAME}.icns")
		set_target_properties(AusweisApp PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${PACKAGING_DIR}/macos/Info.plist.in")
		set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_DEBUG_INFORMATION_FORMAT "dwarf-with-dsym")
	endif()
endif()


if(IOS)
	get_target_property(QT_BUILD_TYPE ${Qt}::Core IMPORTED_CONFIGURATIONS)
	if(QT_BUILD_TYPE STREQUAL "DEBUG")
		set(qt_suffix "_debug")
	endif()

	target_link_libraries(AusweisApp PRIVATE OpenSSL::Crypto OpenSSL::SSL) # remove this if iOS uses shared libraries
	target_link_libraries(AusweisApp PRIVATE -L${QT_INSTALL_ARCHDATA}/plugins/platforms)
	target_link_libraries(AusweisApp PRIVATE -L${QT_INSTALL_ARCHDATA}/plugins/imageformats)
	target_link_libraries(AusweisApp PRIVATE -L${QT_INSTALL_ARCHDATA}/lib)
	target_link_libraries(AusweisApp PRIVATE ${Qt}::Core ${Qt}::Network)
	target_link_libraries(AusweisApp PRIVATE -lqios${qt_suffix})

	target_link_libraries(AusweisApp PRIVATE "-lc++ -lz -lm")
	target_link_libraries(AusweisApp PRIVATE ${IOS_ASSETSLIBRARY} ${IOS_UIKIT} ${IOS_COREFOUNDATION} ${IOS_OPENGLES} ${IOS_FOUNDATION} ${IOS_QUARTZCORE} ${IOS_CORETEXT} ${IOS_COREGRAPHICS} ${IOS_SECURITY} ${IOS_NETWORK} ${IOS_MOBILECORESERVICES} ${IOS_AUDIOTOOLBOX} ${IOS_IMAGEIO} ${IOS_CORENFC} ${IOS_MESSAGEUI} ${IOS_STOREKIT})
	target_link_libraries(AusweisApp PRIVATE -Wl,-e,_qt_main_wrapper)

	if(TARGET ${Qt}::Qml)
		target_link_libraries(AusweisApp PRIVATE ${Qt}::Gui ${Qt}::Svg ${Qt}::Qml ${Qt}::Quick ${Qt}::QuickControls2 ${Qt}::QuickTemplates2)
		target_link_libraries(AusweisApp PRIVATE -lqsvg${qt_suffix} -lqjpeg${qt_suffix})
		target_link_libraries(AusweisApp PRIVATE AusweisAppQmlPlugins)
	endif()

	set_target_properties(AusweisApp PROPERTIES RESOURCE "${IOS_RESOURCES}")
	set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_SKIP_INSTALL "NO")
	set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_ASSETCATALOG_COMPILER_APPICON_NAME "AppIcon")
	set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_TARGETED_DEVICE_FAMILY "1,2")
	set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_CODE_SIGN_ENTITLEMENTS "${PACKAGING_DIR}/ios/AusweisApp2.entitlements")

	if(INTEGRATED_SDK)
		GET_PUBLIC_HEADER(AusweisAppUiFunctional PUBLIC_HEADER)
		target_sources(AusweisApp PUBLIC ${PUBLIC_HEADER})
		set_target_properties(AusweisApp PROPERTIES FRAMEWORK TRUE FRAMEWORK_VERSION C MACOSX_FRAMEWORK_IDENTIFIER ${BUNDLE_IDENTIFIER})
		set_target_properties(AusweisApp PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION} PUBLIC_HEADER ${PUBLIC_HEADER})
		set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_INSTALL_PATH "@rpath")
	else()
		if(USE_DISTRIBUTION_PROFILE)
			set(PROVISIONING_PROFILE_SPECIFIER "iOS Release (Distribution)")
			set(EXPORT_METHOD app-store)
			set(XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Distribution: Governikus GmbH & Co. KG (G7EQCJU4BR)")
		else()
			set(PROVISIONING_PROFILE_SPECIFIER "iOS Development")
			set(EXPORT_METHOD development)
			set(XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Developer: Marco von der Puetten (46ZK7WV8QR)")
		endif()
		set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_PROVISIONING_PROFILE_SPECIFIER ${PROVISIONING_PROFILE_SPECIFIER})
		set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_INSTALL_PATH "$(LOCAL_APPS_DIR)")
		set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY ${XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY})
	endif()

	# prevent xcode to convert multiple png files to tiff
	set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_COMBINE_HIDPI_IMAGES "NO")

	configure_file(${PACKAGING_DIR}/ios/exportOptions.plist.in ${CMAKE_BINARY_DIR}/exportOptions.plist @ONLY)
endif()

if(MAC)
	target_link_libraries(AusweisApp PRIVATE ${OSX_APPKIT})

	set(AUTOSTART_HELPER_NAME AutostartHelper)
	set(AUTOSTART_HELPER_FULL_NAME ${PROJECT_NAME}${AUTOSTART_HELPER_NAME})
	set(AUTOSTART_HELPER_SOURCES autostart_helper/main.mm)
	set(AUTOSTART_HELPER_BUNDLE_ID "com.governikus.AusweisApp2.${AUTOSTART_HELPER_NAME}")
	add_executable(${AUTOSTART_HELPER_FULL_NAME} MACOSX_BUNDLE ${AUTOSTART_HELPER_SOURCES})
	target_link_libraries(${AUTOSTART_HELPER_FULL_NAME} ${OSX_APPKIT})
	set_target_properties(${AUTOSTART_HELPER_FULL_NAME} PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${PACKAGING_DIR}/macos/autostart_helper/Info.plist.in)
endif()

if(WIN32)
	target_link_libraries(AusweisApp PRIVATE ${WIN_DEFAULT_LIBS})
endif()

#####################################################################
# ui
#####################################################################

if(ANDROID)
	target_link_libraries(AusweisApp PRIVATE AusweisAppUiAidl)
	if(NOT INTEGRATED_SDK)
		target_link_libraries(AusweisApp PRIVATE AusweisAppUiLocalIfd)
	endif()
else()
	target_link_libraries(AusweisApp PRIVATE debug AusweisAppUiAidl)
endif()

if(TARGET ${Qt}::Qml)
	target_link_libraries(AusweisApp PRIVATE AusweisAppUiQml)
endif()

if(INTEGRATED_SDK AND NOT ANDROID AND NOT CONTAINER_SDK)
	target_link_libraries(AusweisApp PRIVATE AusweisAppUiFunctional)
endif()

if((NOT ANDROID AND NOT IOS AND NOT INTEGRATED_SDK) OR CONTAINER_SDK)
	target_link_libraries(AusweisApp PRIVATE AusweisAppUiWebsocket)
endif()

if(CONTAINER_SDK OR DESKTOP)
	target_link_libraries(AusweisApp PRIVATE AusweisAppUiAutomatic)
endif()

if(DESKTOP)
	target_link_libraries(AusweisApp PRIVATE AusweisAppUiWebservice)
	target_link_libraries(AusweisApp PRIVATE AusweisAppUiProxy)
endif()

if((ANDROID OR IOS) AND NOT INTEGRATED_SDK)
	target_link_libraries(AusweisApp PRIVATE AusweisAppUiScheme)
endif()

#####################################################################
# card
#####################################################################

if(ANDROID)
	target_link_libraries(AusweisApp PRIVATE AusweisAppCardNfc)
	if(INTEGRATED_SDK)
		target_link_libraries(AusweisApp PRIVATE AusweisAppIfdLocal)
	endif()
endif()

if(IOS)
	target_link_libraries(AusweisApp PRIVATE AusweisAppCardNfc)
endif()

if(TARGET AusweisAppCardSmart)
	if(((ANDROID OR IOS) AND NOT INTEGRATED_SDK) OR CONTAINER_SDK)
		target_link_libraries(AusweisApp PRIVATE AusweisAppCardSmart)
	else()
		target_link_libraries(AusweisApp PRIVATE debug AusweisAppCardSmart)
	endif()
endif()

if(DESKTOP)
	target_link_libraries(AusweisApp PRIVATE AusweisAppCardPcsc AusweisAppCardDrivers)
endif()

target_link_libraries(AusweisApp PRIVATE AusweisAppCardSimulator)

#####################################################################

include(Install)
include(FeatureSummary)
FEATURE_SUMMARY(WHAT ALL)

=== test/CMakeLists.txt ===
function(EXTRACT_TESTNAME result filepath)
	string(REPLACE ".cpp" "" testname ${filepath})
	string(REPLACE ".mm" "" testname ${testname})
	string(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}/" "" testname ${testname})
	string(REPLACE "/" "_" testname ${testname})
	string(REPLACE "+" "" testname ${testname})
	string(REPLACE "_test_" "_" testname ${testname})
	set(${result} "Test_${testname}" PARENT_SCOPE)
endfunction()


function(GET_TEST_CMDLINE cmdline testname)
	cmake_parse_arguments(_PARAM "" "" "SELECTORS" ${ARGN})

	foreach(SELECTOR ${_PARAM_SELECTORS})
		set(testname "${testname}_${SELECTOR}")
	endforeach()

	set(${cmdline} ${PLATFORM} -v2 -o ${CMAKE_CURRENT_BINARY_DIR}/results.${testname}.log.xml,xml -o -,txt PARENT_SCOPE)
endfunction()

function(GET_TEST_ENV testenv testname)
	set(IS_QML_TEST "${testname}" MATCHES "qml")
	set(IS_GUI_TEST IS_QML_TEST OR "${testname}" MATCHES "PdfExporter")

	if(NOT WIN32 AND IS_GUI_TEST)
		list(APPEND ENV "QT_QPA_PLATFORM=offscreen")
		list(APPEND ENV "QT_QPA_OFFSCREEN_NO_GLX=1")
	endif()

	set(IS_FLAKY_QT5_TEST "${testname}" MATCHES "UIPlugInWebSocket")
	# Emasculate ASAN since Qt causes problems
	if(IS_GUI_TEST OR (QT5 AND IS_FLAKY_QT5_TEST))
		list(APPEND ENV "ASAN_OPTIONS=detect_leaks=0")
	endif()

	if(IS_GUI_TEST)
		list(APPEND ENV "QML_DISABLE_DISK_CACHE=1")
	endif()

	list(APPEND ENV "QT_ENABLE_REGEXP_JIT=0")

	set(${testenv} "${ENV}" PARENT_SCOPE)
endfunction()


function(ADD_QML_TEST _sourcefile)
	cmake_parse_arguments(_PARAM "" "" "SELECTORS" ${ARGN})

	EXTRACT_TESTNAME(TESTNAME ${_sourcefile})
	GET_TEST_CMDLINE(CMD_PARAMS ${TESTNAME} SELECTORS ${_PARAM_SELECTORS})
	set(CMD $<TARGET_FILE:QmlTestRunner> ${CMD_PARAMS} -input ${sourcefile} -import "qrc:///qml/")

	if(_PARAM_SELECTORS)
		foreach(_PARAM_SELECTOR_LIST_ENTRY ${_PARAM_SELECTORS})
			set(TESTNAME ${TESTNAME}_${_PARAM_SELECTOR_LIST_ENTRY})
			set(CMD ${CMD} -file-selector ${_PARAM_SELECTOR_LIST_ENTRY})
		endforeach()
	endif()

	GET_TEST_ENV(TESTENV ${TESTNAME})

	add_test(NAME ${TESTNAME} COMMAND ${CMD})
	set_tests_properties(${TESTNAME} PROPERTIES ENVIRONMENT "${TESTENV}")
	set_tests_properties(${TESTNAME} PROPERTIES LABELS "qml" TIMEOUT 90)
endfunction()


function(ADD_QML_TEST_FILES)
	if(BSD)
		message(STATUS "Qml tests on BSD are not supported")
		return()
	endif()

	if(QT6)
		set(qt_selector qt6)
	else()
		set(qt_selector qt5)
	endif()

	file(GLOB_RECURSE TEST_SUBFILES "${CMAKE_CURRENT_SOURCE_DIR}/test_*.qml")
	foreach(sourcefile ${TEST_SUBFILES})
		string(REGEX MATCHALL "\\+[a-z]+" PLATFORM_FILTER ${sourcefile})
		if(NOT "+mobile" IN_LIST PLATFORM_FILTER)
			if(NOT "+mac" IN_LIST PLATFORM_FILTER)
				ADD_QML_TEST(${sourcefile} SELECTORS "${qt_selector};desktop;win")
			endif()
			if(NOT "+win" IN_LIST PLATFORM_FILTER)
				ADD_QML_TEST(${sourcefile} SELECTORS "${qt_selector};desktop;mac")
			endif()
		endif()
		if(NOT "+desktop" IN_LIST PLATFORM_FILTER)
			if(NOT "+tablet" IN_LIST PLATFORM_FILTER)
				if(NOT "+ios" IN_LIST PLATFORM_FILTER)
					ADD_QML_TEST(${sourcefile} SELECTORS "${qt_selector};mobile;phone;android")
				endif()
				if(NOT "+android" IN_LIST PLATFORM_FILTER)
					ADD_QML_TEST(${sourcefile} SELECTORS "${qt_selector};mobile;phone;ios")
				endif()
			endif()
			if(NOT "+phone" IN_LIST PLATFORM_FILTER)
				if(NOT "+ios" IN_LIST PLATFORM_FILTER)
					ADD_QML_TEST(${sourcefile} SELECTORS "${qt_selector};mobile;tablet;android")
				endif()
				if(NOT "+android" IN_LIST PLATFORM_FILTER)
					ADD_QML_TEST(${sourcefile} SELECTORS "${qt_selector};mobile;tablet;ios")
				endif()
			endif()
		endif()
	endforeach()
endfunction()

qt_add_resources(QRC_FIXTURE "fixture/fixture.qrc" OPTIONS -compress-algo zlib)
ADD_OBJECT_LIBRARY(QRC_FIXTURE_OBJ ${QRC_FIXTURE} ${Qt}::Core)

add_subdirectory(helper)
if(TARGET ${Qt}::Qml AND TARGET ${Qt}::QuickTest)
	add_subdirectory(qml)
endif()
add_subdirectory(qt)
add_subdirectory(json)

if(NOT INTEGRATED_SDK AND NOT IOS AND NOT ANDROID)
	add_subdirectory(integration)
endif()

if(INTEGRATED_SDK AND NOT CONTAINER_SDK AND NOT ANDROID)
	add_subdirectory(integrated)
endif()

=== resources/qml/CMakeLists.txt ===
if(IOS)
	add_library(AusweisAppQmlPlugins INTERFACE)
	qt_import_qml_plugins(AusweisAppQmlPlugins)
endif()

=== src/core/CMakeLists.txt ===
#####################################################################
# The module core is responsible to start up the application and main
# event loop. It will initialize any necessary module and control
# any workflow and communication between the modules.
#####################################################################

ADD_PLATFORM_LIBRARY(AusweisAppCore)

target_link_libraries(AusweisAppCore AusweisAppCard AusweisAppGlobal AusweisAppNetwork AusweisAppServices AusweisAppSettings AusweisAppUi AusweisAppWorkflows)

=== src/diagnosis/CMakeLists.txt ===
#####################################################################
# The module diagnosis is responsible to collect and present all
# diagnosis data.
#####################################################################
if(DESKTOP AND TARGET ${Qt}::Qml)
	ADD_PLATFORM_LIBRARY(AusweisAppDiagnosis)

	target_link_libraries(AusweisAppDiagnosis ${Qt}::Qml AusweisAppCard)
endif()

=== src/export/CMakeLists.txt ===
#####################################################################
# The module export is responsible to export certain data to other
# file formats.
# Supported: PDF
#####################################################################

if(TARGET ${Qt}::Svg)
	ADD_PLATFORM_LIBRARY(AusweisAppExport)

	target_link_libraries(AusweisAppExport ${Qt}::Core ${Qt}::Svg AusweisAppCard AusweisAppSettings)
endif()

=== src/global/CMakeLists.txt ===
#####################################################################
# The module global is responsible for general utilities like
# logging or loader for resources and translations.
#####################################################################

ADD_PLATFORM_LIBRARY(AusweisAppGlobal)

target_link_libraries(AusweisAppGlobal ${Qt}::Core OpenSSL::Crypto ${OSX_SECURITY})

=== src/init/CMakeLists.txt ===
#####################################################################
# The module init is responsible to bootstrap the application.
#####################################################################

ADD_PLATFORM_LIBRARY(AusweisAppInit)

target_link_libraries(AusweisAppInit ${Qt}::Core OpenSSL::Crypto AusweisAppGlobal AusweisAppCore)

if(QT6)
    target_link_libraries(AusweisAppInit ${Qt}::CorePrivate)
endif()

if(NOT INTEGRATED_SDK)
	target_link_libraries(AusweisAppInit ${Qt}::Gui) # QGuiApplication
	if(DESKTOP)
		target_link_libraries(AusweisAppInit ${Qt}::Widgets) # QApplication
	endif()
endif()


function(CONFIGURE_CONFIG_H)
	if(VENDOR_GOVERNIKUS)
		set(VENDOR_DOMAIN governikus.com)
	else()
		set(VENDOR_DOMAIN)
	endif()

	if(VERSION_DVCS)
		set(VERSION ${VERSION_DVCS})
	else()
		set(VERSION ${PROJECT_VERSION})
	endif()

	set(PRODUCT ${PROJECT_NAME})

	configure_file(config.h.in config.h @ONLY)
endfunction()

CONFIGURE_CONFIG_H()

=== debian/changelog ===
ausweisapp2 (1.26.2-1) unstable; urgency=medium

  * New upstream release

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Mon, 23 Jan 2023 11:26:14 +0100

=== debian/control ===
Source: ausweisapp2
Section: utils
Priority: optional
Maintainer: John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>
Build-Depends: cmake,
               debhelper-compat (= 12),
               libhttp-parser-dev,
               libpcsclite-dev,
               libqt6opengl6-dev,
               libqt6shadertools6-dev,
               libqt6svg6-dev,
               libqt6websockets6-dev,
               libssl-dev,
               libudev-dev,
               pkg-config,
               qt6-base-dev,
               qt6-base-private-dev,
               qt6-declarative-dev,
               qt6-scxml-dev,
               qt6-tools-dev
Standards-Version: 4.6.1
Homepage: https://www.ausweisapp.bund.de
Vcs-Browser: https://salsa.debian.org/debian/ausweisapp2
Vcs-Git: https://salsa.debian.org/debian/ausweisapp2.git

Package: ausweisapp2
Architecture: any
Depends: qml6-module-qt-labs-platform,
         qml6-module-qtqml,
         qml6-module-qtqml-models,
         qml6-module-qtqml-statemachine,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-layouts,
         qml6-module-qtquick-templates,
         qml6-module-qtquick-window,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: pcsc-tools, pcscd
Description: Official authentication app for German ID cards and residence permits
 This app is developed and issued by the German government to be
 used for online authentication with electronic German ID cards
 and residence titles. To use this app, a supported RFID card
 reader or compatible NFC smart phone is required.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	install -Dm 644 $(CURDIR)/resources/images/npa.png $(CURDIR)/debian/ausweisapp2/usr/share/icons/hicolor/96x96/apps/AusweisApp2.png

## ausweisapp2 1.26.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -60,7 +60,7 @@
 	set(CMAKE_OSX_DEPLOYMENT_TARGET 10.15 CACHE STRING "Required macOS version")
 endif()
 
-project(AusweisApp2 VERSION 1.26.2 LANGUAGES ${LANGUAGES})
+project(AusweisApp2 VERSION 1.26.3 LANGUAGES ${LANGUAGES})
 
 # Set TWEAK if not defined in PROJECT_VERSION above to
 # have a valid tweak version without propagating it

=== libs/CMakeLists.txt ===
--- 
+++ 
@@ -112,8 +112,8 @@
 set(QT 6.4.1)
 set(QT_HASH e20b850b6134098a7f2e7701cfddfb213c6cf394b9e848e6fbc5b0e89dcfcc09)
 
-set(OPENSSL 3.0.7)
-set(OPENSSL_HASH 83049d042a260e696f62406ac5c08bf706fd84383f945cf21bd61e9ed95c396e)
+set(OPENSSL 3.0.8)
+set(OPENSSL_HASH 6c13d2bf38fdf31eac3ce2a347073673f5d63263398f1f69d0df4a41253e4b3e)
 
 ################################## Files
 set(QT_FILE qt-everywhere-src-${QT}.tar.xz)

=== debian/changelog ===
ausweisapp2 (1.26.3-1) unstable; urgency=medium

  * New upstream release

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sun, 12 Mar 2023 18:18:21 +0100

## ausweisapp2 1.26.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -60,7 +60,7 @@
 	set(CMAKE_OSX_DEPLOYMENT_TARGET 10.15 CACHE STRING "Required macOS version")
 endif()
 
-project(AusweisApp2 VERSION 1.26.3 LANGUAGES ${LANGUAGES})
+project(AusweisApp2 VERSION 1.26.5 LANGUAGES ${LANGUAGES})
 
 # Set TWEAK if not defined in PROJECT_VERSION above to
 # have a valid tweak version without propagating it
@@ -182,6 +182,7 @@
 option(USE_SMARTEID "Enable Smart-eID" OFF)
 
 include(Libraries)
+include(Tools.Libraries)
 include(CompilerFlags)
 
 if(LINUX OR BSD)
@@ -200,3 +201,6 @@
 endif()
 
 include(Packaging)
+
+include(FeatureSummary)
+FEATURE_SUMMARY(WHAT ALL)

=== debian/changelog ===
ausweisapp2 (1.26.5-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Tue, 01 Aug 2023 12:12:32 +0200

ausweisapp2 (1.26.5-1) unstable; urgency=medium

  * New upstream release

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Thu, 27 Jul 2023 07:51:47 +0200

ausweisapp2 (1.26.4-1) unstable; urgency=medium

  * New upstream release

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Thu, 11 May 2023 09:52:39 +0200
